SystemOrganization addCategory: #'Manifest-CriticBrowser'!

!RBCompositeLintRule methodsFor: '*Manifest-CriticBrowser' stamp: 'StephaneDucasse 11/21/2012 18:25'!
removeRule: aRule

	(rules anySatisfy: [ :rule | rule name = aRule name] )
		ifTrue: [rules := rules reject:  [ :rule | rule name = aRule name]]
		 ifFalse: [rules do: [ :rule |
				rule isComposite 
					ifTrue: [rule removeRule: aRule]]] ! !

!RBCompositeLintRule methodsFor: '*Manifest-CriticBrowser' stamp: 'StephaneDucasse 11/21/2012 18:25'!
sort: aBlock
	
	rules first isComposite
		 ifTrue: [ rules do: [ :rule | rule sort: aBlock ]] 
		ifFalse: [ self rules: (rules sort: aBlock) ]! !

ComposableModel subclass: #CommentWindow
	instanceVariableNames: 'okCancelToolBarModel commentInputFieldModel rule critic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CommentWindow commentStamp: '<historical>' prior: 0!
A simple dialog to get a comment for the situation.!

CommentWindow subclass: #CommentFalsePositiveWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CommentFalsePositiveWindow commentStamp: '<historical>' prior: 0!
To enter comment for false positives.!

!CommentFalsePositiveWindow class methodsFor: 'instance creation' stamp: 'StephaneDucasse 11/21/2012 17:49'!
openOnCritic: aCritc onRule: aRule
	
	self new
		critic: aCritc;
		rule: aRule;
		initializeForFalsePositive;		
		openWithSpec. ! !

!CommentFalsePositiveWindow methodsFor: 'initialization' stamp: 'StephaneDucasse 11/21/2012 17:49'!
initializeForFalsePositive
	self initializeTextForFalsePositive.
	
	okCancelToolBarModel okAction: [ | manifestBuilder rId rV|
		rId :=  rule class uniqueIdentifierName.
		rV :=   rule class identifierMinorVersionNumber.
		manifestBuilder := BuilderManifest on: critic.
		
		(manifestBuilder hasFalsePositiveOf: rId version: rV) 
			ifFalse: [manifestBuilder installFalsePositiveOf: rId version: rV].
		
		manifestBuilder
			addFalsePositive: critic  withComment:  (commentInputFieldModel getText)  of: rId version: rV]! !

!CommentFalsePositiveWindow methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:34'!
initializeTextForFalsePositive
	| ruleId versionId  manifestBuilder|
	manifestBuilder := BuilderManifest on: critic.
	ruleId :=  rule class uniqueIdentifierName.
	versionId := rule class identifierMinorVersionNumber.
	
	(manifestBuilder hasFalsePositiveOf: ruleId version: versionId)
		ifFalse: [^ self] .
	
	commentInputFieldModel text: ((BuilderManifest on: critic) commentOfFalsePositive: critic onRule: ruleId version: versionId)  ! !

!CommentFalsePositiveWindow methodsFor: 'initialization' stamp: 'Sd 11/30/2012 16:43'!
initializeWidgets

	^ #()! !

CommentWindow subclass: #CommentToDoWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CommentToDoWindow commentStamp: '<historical>' prior: 0!
To enter comment for todos.!

!CommentToDoWindow class methodsFor: 'instance creation' stamp: 'StephaneDucasse 11/21/2012 17:49'!
openOnCritic: aCritc onRule: aRule
	
	self new
		critic: aCritc;
		rule: aRule;
		initializeForToDo;		
		openWithSpec. ! !

!CommentToDoWindow methodsFor: 'initialization' stamp: 'StephaneDucasse 11/21/2012 17:50'!
initializeForToDo
	self initializeTextForToDo.
	
	okCancelToolBarModel okAction: [ | manifestBuilder rId rV|
		rId :=  rule class uniqueIdentifierName.
		rV :=   rule class identifierMinorVersionNumber.
		manifestBuilder := BuilderManifest on: critic.
		
		(manifestBuilder hasToDoOf: rId version: rV) 
			ifFalse: [manifestBuilder installToDoOf: rId version: rV].
		
		manifestBuilder
			addToDo: critic  withComment:  (commentInputFieldModel getText)  of: rId version: rV]! !

!CommentToDoWindow methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:35'!
initializeTextForToDo

	| ruleId versionId  manifestBuilder|
	manifestBuilder := 	BuilderManifest on: critic.
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	(manifestBuilder hasToDoOf: ruleId version: versionId)
		ifFalse: [^ self] .
	commentInputFieldModel text: ((BuilderManifest on: critic) commentOfToDo: critic onRule: ruleId version: versionId)  ! !

!CommentWindow class methodsFor: 'specs' stamp: 'SimonAllier 7/25/2012 10:24'!
defaultSpec
	
	^ { #Panel.
			#useProportionalLayout.
			
			#add:. {{#model.	#commentInputField.}	.
							#layout:. {#FrameLayout.
										#fractions:offsets:. (0@0 corner: 1@1). (0@0 corner: 0@(-25))}}.
			
			#add:. {{#model.	#okCancelToolBar.}	.
							#layout:. {#FrameLayout.
										#fractions:offsets:. (0@1 corner: 1@1). (0@(-25) corner: 0@0)}}.
			
			
			#hSpaceFill.
			#vSpaceFill }! !

!CommentWindow class methodsFor: 'specs' stamp: 'SimonAllier 3/30/2012 15:04'!
title
	^ 'Comment'! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 14:58'!
commentInputField
	^ commentInputFieldModel! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 15:50'!
critic: aCritic
	critic := aCritic! !

!CommentWindow methodsFor: 'protocol' stamp: 'StephaneDucasse 11/21/2012 17:48'!
initialExtent

	^  (465@225)! !

!CommentWindow methodsFor: 'initialization' stamp: 'SimonAllier 5/9/2012 16:42'!
initialize

	super initialize.
	
	okCancelToolBarModel := self instantiate: OkCancelToolbar. 
	commentInputFieldModel := self instantiate: TextModel.
	
	"commentInputFieldModel removeEntryCompletion "
	! !

!CommentWindow methodsFor: 'initialization' stamp: 'Sd 11/29/2012 14:37'!
initializeWidgets
	^ self ! !

!CommentWindow methodsFor: 'protocol' stamp: 'SimonAllier 3/30/2012 16:02'!
okAction: aBlock
	^ okCancelToolBarModel okAction: aBlock! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 14:58'!
okCancelToolBar
	^ okCancelToolBarModel! !

!CommentWindow methodsFor: 'accessing' stamp: 'SimonAllier 3/30/2012 15:50'!
rule: aRule
	rule := aRule! !

ComposableModel subclass: #CriticBrowser
	instanceVariableNames: 'criticModel rulesModel checker thread title numberOfFalsePositives numberOfProblems numberOfToDos rbEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CriticBrowser commentStamp: '<historical>' prior: 0!
I am a browser for the SmallLint Critics

Example: 


| rule environment |
rule :=  RBExcessiveArgumentsRule new.
environment := (RBPackageEnvironment new packages: {RPackageSet named: 'Manifest-Core'}).

(CriticBrowser openOnRule: rule onEnvironment: environment)
	
!

!CriticBrowser class methodsFor: 'menu' stamp: 'StephaneDucasse 12/22/2012 19:52'!
criticsBrowserMenuOn: aBuilder 
	"I build a menu"
	<worldMenu>
	(aBuilder item: 'Critic Browser')
		action: [ self openOnCurrentWorkingConfiguration ];
		order: 10;
		parent: #Tools;
		help: 'To manage rule checks';
		icon: self icon! !

!CriticBrowser class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:55'!
defaultSpec
	<spec>
	
	^ SpecLayout composed 
		newColumn: [:c |
			c 
				newRow: [:r |
					r 
						add: #rulesModel;
						addSplitter;
						newColumn: [:c1 |
							c1 
								add: #(criticModel textInputFieldModel) height: 25;
								add: #(criticModel criticsModel);
								add: #(criticModel toolbarModel) height: 25 ]];
				addSplitter;
				add: #(criticModel textModel) ]! !

!CriticBrowser class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 11/24/2012 17:30'!
icon
	"Answer an icon for the receiver."
	
	^ self theme smallWarningIcon! !

!CriticBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 8/1/2012 11:03'!
open

	| env rules  |
	rules :=  RBCompositeLintRule allGoodRules rules.
	env := (RBPackageEnvironment new packages: ((MCWorkingCopy  allManagers asOrderedCollection) copyFrom: 1 to: 20)).
	
	self openOnRule: rules onEnvironment:  env
	

	.! !

!CriticBrowser class methodsFor: 'menu' stamp: 'StephaneDucasse 12/22/2012 19:52'!
openOnCurrentWorkingConfiguration

	CriticWorkingConfiguration exists
		ifTrue: [ self openOnWorkspace: CriticWorkingConfiguration current ]
		ifFalse: [ SelectPackageBrowser open ]! !

!CriticBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 5/22/2012 15:55'!
openOnRule: aRule onEnvironment: aEnv

	| cbr |
	cbr :=  self new rules: aRule;
		environment: aEnv;
		yourself.

	cbr openWithSpec.
	cbr applyRules. 
	cbr rulesModel  changed:  #listElementAt:.! !

!CriticBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/24/2012 18:12'!
openOnWorkspace: aWorkspace

	| cbr |
	cbr :=  self new 
		rules: aWorkspace rule;
		environment: aWorkspace environment;
		yourself.

	cbr openWithSpec.
	cbr applyRules. 
	cbr rulesModel  changed:  #listElementAt:.! !

!CriticBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 7/31/2012 11:06'!
packagesGroup: aBuilder
	<nautilusGroupMenu>
	| packages target env rules group|
	target := aBuilder model.
	
	
	(group := target selectedGroups) ifNil: [ ^ target ].
	
	packages := (group gather: [:each | each classes collect: [:cl |
			PackageInfo named: (cl package name)]]) asSet.
	
	rules :=   RBCompositeLintRule allGoodRules.
	env := (RBPackageEnvironment new packages: packages ).	
	
	(aBuilder item: #'Critics Browser')
		action: [self openOnRule: rules onEnvironment: env];
		help: 'Running critics rules on this group'.! !

!CriticBrowser class methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/22/2012 19:52'!
packagesMenu: aBuilder
	<nautilusPackageMenu>
	| packages target env rules |
	target := aBuilder model.
	(packages := target selectedPackages) ifNil: [ ^ {target} ].
	rules :=  RBCompositeLintRule allGoodRules.
	env := (RBPackageEnvironment new 
				packages: (packages collect: [:each | PackageInfo named: (each name)]) ).	
	(aBuilder item: #'Critics Browser')
		action: [self  openOnRule: rules onEnvironment: env];
		help: 'Running critics rules on this package'.! !

!CriticBrowser class methodsFor: 'menu' stamp: ''!
theme
	^ UITheme current! !

!CriticBrowser methodsFor: 'user interface' stamp: 'Sd 11/30/2012 17:33'!
addModelItemsToWindowMenu: aMenu
	"Add model-related items to the window menu"
	"super addModelItemsToWindowMenu: aMenu."
	
	aMenu 
		addLine;
		add: 'Clean all manifest'
			target: checker
			action: #cleanAllManifest;
		add: 'Reapply all  rules'
			target: self
			action: #reapplyAllRules! !

!CriticBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/24/2012 16:34'!
addRuleToFalsePositive

	| manifestBuilder |
	rulesModel selectedItem ifNotNil: [ :rule |
		rule leaves do: [: r |
			r critics do: [:cl |
				manifestBuilder := checker manifestBuilderOf: cl. 
				manifestBuilder addRejectRule: r class uniqueIdentifierName]]].
	
	criticModel updateList. 	
	! !

!CriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:26'!
addTruePositive: aItem onRule: aRule	

	| ruleId versionId manifestBuilder |
	ruleId :=  aRule class uniqueIdentifierName.
	versionId :=   aRule class identifierMinorVersionNumber.
	manifestBuilder :=  checker manifestBuilderOf: aItem.
	(manifestBuilder hasTruePositiveOf: ruleId version: versionId) 
			ifFalse: [manifestBuilder installTruePositiveOf: ruleId version: versionId].
	manifestBuilder addTruePositive: aItem of: ruleId version: versionId.
	
	! !

!CriticBrowser methodsFor: 'private' stamp: 'StephaneDucasse 12/22/2012 19:41'!
applyRules

	|  packageCount nbPackage process rules|	
	rules := rulesModel getRoots first.
	rules resetResult.
	nbPackage := rbEnvironment packages size.
	packageCount := 0.
	self updateTree.
	process := [  
		rbEnvironment packages do: [:package ||  windowTitle |
			packageCount := packageCount + 1.
			windowTitle := String streamContents: [:s | 
				s 
					<< 'run rules on '
					<< package packageName
					<< ' ('
					<< packageCount asString
					<< '/'
					<< nbPackage asString
					<< ')' ].				
			self setTitle: windowTitle.
			checker runRules: rules onPackage: package ].
	
		self setTitle: 'Critics Browser'.
		self collectRulesData. 
		self updateTree.
		self registerToAnnouncements ] newProcess.

	process name: 'SmallLint'.
	process resume.! !

!CriticBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/24/2012 16:43'!
browseRule

	rulesModel selectedItem ifNotNil: [:rule | rule browse ]! !

!CriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:26'!
bugRule

	| ruleId versionId manifestBuilder |
	ruleId :=  BugRule uniqueIdentifierName.
	versionId :=  BugRule identifierMinorVersionNumber.
	rulesModel selectedItem ifNotNil: [ :rule |
		manifestBuilder := checker manifestBuilderOf: rule class.
		(manifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifFalse: [ 
				manifestBuilder 
					installFalsePositiveOf: ruleId 
					version: versionId ].
	 	manifestBuilder 
			addFalsePositive: rule class
			of: ruleId 
			version: versionId.
			
		CommentToDoWindow openOnCritic: rule class onRule: BugRule new ]

	! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'Sd 11/30/2012 17:27'!
classModified: anAnnouncement
	"checks if a modification of a class fixes a warning. if true,  the true/false positives in the browser are update"
	
	|  class  |
	class := anAnnouncement class.
	class isManifest ifTrue: [ ^ self ].	
	(criticModel criticsModelContains: anAnnouncement class) ifFalse: [^ self].
	self reapplyThisRule	! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'StephaneDucasse 12/22/2012 19:41'!
classRemoved: anAnnouncement
	
	(rbEnvironment classes anySatisfy: [ :cl | anAnnouncement classRemoved = cl ]) 
		ifFalse: [ ^ self ].
	rulesModel getList do: [ :rule | 
		self removeClass: anAnnouncement classRemoved onRule: rule ].
	self updateTree! !

!CriticBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 11/24/2012 16:22'!
collectRulesData
	"Iterates over rules and calculate some information"
	
	rulesModel getRoots do: [:rule | self updateCountOf: rule ]! !

!CriticBrowser methodsFor: 'accessing' stamp: ''!
criticModel
	^ criticModel! !

!CriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:28'!
doNotUnderstandThisRule

	| ruleId versionId manifestBuilder |
	ruleId :=  DoNotUnderstandThisRule uniqueIdentifierName.
	versionId :=  DoNotUnderstandThisRule identifierMinorVersionNumber.

	rulesModel selectedItem ifNotNil: [ :rule |
		manifestBuilder :=  checker manifestBuilderOf: rule class.
		(manifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifFalse: [manifestBuilder installFalsePositiveOf: ruleId version: versionId].
	 	manifestBuilder addFalsePositive: (rule class) of: ruleId version: versionId.
		
		CommentToDoWindow openOnCritic: rule class onRule: DoNotUnderstandThisRule new ]

	! !

!CriticBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 12/22/2012 19:41'!
environment: aEnv
	rbEnvironment := aEnv
! !

!CriticBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/24/2012 17:18'!
initialExtent

	^   760@370! !

!CriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:28'!
initialize
	"Initialization code for CriticRulesBrowser"
	
	super initialize.
	checker := SmalllintManifestChecker new.
	criticModel checker: checker.	
	numberOfFalsePositives := Dictionary new.
	numberOfToDos := Dictionary new.	
	numberOfProblems := Dictionary new.	
		
! !

!CriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:29'!
initializeDisplayBlockForRules

	rulesModel displayBlock: [:rule || falsePositives toDos total text |
		falsePositives := (numberOfFalsePositives at: rule ifAbsent: [ 0 ]) .
		toDos := (numberOfToDos at: rule ifAbsent: [ 0 ]) .
		total :=   (numberOfProblems at: rule ifAbsent: [ 0 ]) .
		text := String streamContents: [:s |
			s 
				<< rule name 
				<< ' (FP: ' 
				<< falsePositives asString 
				<< ', ToDo: '
				<< toDos asString 
				<< ', Total: ' 
				<<  total asString 
				<<  ')' ].
		total isZero
			ifTrue: [ text ] 
			ifFalse: [
				falsePositives >= total
					ifTrue: [ text asText makeAllColor: criticModel falsePositiveColor ]
					ifFalse: [ text asText makeAllColor: criticModel defaultColor ]]]! !

!CriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:29'!
initializePresenter

	rulesModel whenSelectedItemChanged: [:rule |
		(rule isNil or: [ rule isComposite ]) ifFalse: [
			criticModel resetSelection.
	 		criticModel rule: rule. 	
			criticModel setTextModelForNil]].! !

!CriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:29'!
initializeWidgets
	
	title := 'Critic Browser'.
	rulesModel := self instantiate: TreeModel.
	criticModel := SingleRuleCriticBrowser new.
	rulesModel childrenBlock: [:rule | 
		rule isComposite 
			ifTrue: [ rule rules ]
			ifFalse: [ #() ]]. 

	rulesModel menu: [:a :b | self menu: a shifted: b ].	
	self initializeDisplayBlockForRules.
	
	self focusOrder
		add: rulesModel;
		add: criticModel! !

!CriticBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 12/22/2012 19:55'!
menu: aMenu shifted: aBoolean

	aMenu
		add: 'Browse rule' translated
			target: self
			selector: #browseRule;
		add: 'Do not understand this rule' translated
			target: self
			selector: #doNotUnderstandThisRule;
		add: 'This rule contains a bug' translated
			target: self
			selector: #bugRule;
		add: 'Reapply this rule'
			target: self
			selector: #reapplyThisRule;
		addLine;
		add: 'Ban this rule for all packages' translated
			target: self
			selector: #addRuleToFalsePositive;
		add: 'Unban this rule for all packages' translated
			target: self
			selector: #removeRuleToFalsePositive;
		addLine; 
		add: 'Reset working package sets' translated
			target: self
			selector: #resetWorkingConfiguration.
	 ^ aMenu! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 8/13/2012 10:26'!
methodAdded: anAnnouncement
	anAnnouncement methodClass isManifest
		ifFalse: [ ^ self ].
	self updateCountOf: rulesModel selectedItem.
	self updateTree! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 8/13/2012 10:29'!
methodModified: anAnnouncement
"checks if a modification of a method fixes a warning. if true,  the true positives in the browser are update"
"checks  if  a method of a manifest class is modified and update false positive in the browser"
	| class  |
	
	class := anAnnouncement methodClass.
	class isManifest 
		ifTrue: [ self updateCountOf: (rulesModel selectedItem).
			self updateTree
.			^ self].
		
	(criticModel criticsModelContains: anAnnouncement oldMethod)
		ifFalse: [^ self].
		
	self reapplyThisRule	
! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'StephaneDucasse 12/22/2012 19:41'!
methodRemoved: anAnnouncement

	(rbEnvironment classes anySatisfy: [ :cl | anAnnouncement methodClass = cl ])
		ifFalse: [ ^ self ].
	rulesModel getRoots do: [:root |
		root leaves do: [ :rule |
			 self removeClass: anAnnouncement methodClass selector: anAnnouncement selector onRule: rule]].
	self updateTree! !

!CriticBrowser methodsFor: 'display' stamp: ''!
open

	window := self openWithSpec.
	^ window.! !

!CriticBrowser methodsFor: 'protocol' stamp: ''!
openWithSpec

	window := super openWithSpec.
	^ window.! !

!CriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:30'!
reapplyAllRules
	
	|  ruleCount total  rule |
	ruleCount := 0.
	rule := rulesModel getRoots first.
	total := rule leaves size.

	 rule leaves do: [ :r |
		ruleCount := ruleCount + 1.
		self setTitle: (String streamContents: [:s | s << 'run rules: ' << r name << ' (' << ruleCount asString << '/' << total asString <<')']).
		self reapplyRule: r ]. 	
	self setTitle: 'Critics Browser'.
	
	self updateCountOf: rule.
	 criticModel updateList.
	 rulesModel updateTree! !

!CriticBrowser methodsFor: 'private' stamp: 'StephaneDucasse 12/22/2012 19:41'!
reapplyRule: aRule

	|  oldCritics |
	oldCritics := aRule critics.
	aRule resetResult.
	rbEnvironment packages do: [:package |
		checker runRules: aRule onPackage: package ]. 	
	(oldCritics \ (aRule critics)) do: [:each |
		self addTruePositive: each onRule: aRule].
	checker rule: aRule. ! !

!CriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:25'!
reapplyThisRule

	| rule |
	rulesModel selectedItem isNil
		ifTrue: [^ self].
	rule := rulesModel selectedItem. 
	rule leaves do: [:each |	self reapplyRule: each]. 
	
	criticModel resetSelection. 
	criticModel rule: rule.
	checker rule: rule. 
	self updateCountOf: rule.
	criticModel updateList. 
	self updateTree ! !

!CriticBrowser methodsFor: 'system annoucements' stamp: 'BenjaminVanRyseghem 11/24/2012 16:40'!
registerToAnnouncements

	SystemAnnouncer uniqueInstance weak
		on: ClassRemoved send: #classRemoved: to: self;
		on: MethodAdded send: #methodAdded: to: self;
		on: MethodModified send: #methodModified: to: self;
		on: MethodRemoved send: #methodRemoved: to: self.! !

!CriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:31'!
removeClass: aClass  onRule: aRule
	| result |
	result := aRule result.
	result isVariableEnvironment
		ifTrue: [
			aClass classVarNames do: [ :var | result removeClass: aClass classVariable: var ].
			aClass instVarNames do: [ :var | result removeClass: aClass instanceVariable: var ]]
		ifFalse: [ result removeClass: aClass ]
	! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 8/1/2012 13:34'!
removeClass: aClass selector: aSelector onRule: aRule
	| result |
	result := aRule result.
	result isClassEnvironment
		ifTrue: [ result removeClass: aClass ].
	result isSelectorEnvironment
		ifTrue: [ result removeClass: aClass selector: aSelector ].
	result isVariableEnvironment
		ifFalse: [ ^ self ].
	aClass classVarNames do: [ :var | result removeClass: aClass classVariable: var ].
	aClass instVarNames do: [ :var | result removeClass: aClass instanceVariable: var ]! !

!CriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:32'!
removeRuleToFalsePositive

	| manifestBuilder |
	rulesModel selectedItem ifNotNil: [ :rule |
		rule leaves do: [ :r |
			r critics do: [ :cl |
				manifestBuilder := checker manifestBuilderOf: cl. 
				manifestBuilder removeRejectRule: r class uniqueIdentifierName]]].
	criticModel updateList.
	
	! !

!CriticBrowser methodsFor: 'private' stamp: 'StephaneDucasse 12/22/2012 19:57'!
resetWorkingConfiguration

	"For now we do not remember what was previously selected."
	CriticWorkingConfiguration reset.! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 5/22/2012 16:00'!
rules: aCompositeRule

	self rulesModel roots: {aCompositeRule}
	
	
! !

!CriticBrowser methodsFor: 'accessing' stamp: ''!
rulesModel

	^ rulesModel! !

!CriticBrowser methodsFor: 'protocol' stamp: 'Sd 11/30/2012 17:32'!
setTitle: aTitle
	title := aTitle.
	self window updateTitle 
	! !

!CriticBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/24/2012 17:29'!
taskbarIcon

	^ self class icon! !

!CriticBrowser methodsFor: 'protocol' stamp: 'SimonAllier 7/27/2012 11:08'!
title
	^ title! !

!CriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:32'!
updateCountOf: aRule

	aRule isNil ifTrue: [^ self].
	checker rule: aRule.
	aRule isComposite 
		ifTrue: [aRule rules do: [:rule |
			self updateCountOf: rule].
	numberOfFalsePositives 
		at: aRule
		put: (aRule rules inject: 0 into: [:count :each | 
			count + numberOfFalsePositives at: each]).
	numberOfToDos 
		at: aRule
		put: (aRule rules inject: 0 into: [:count :each | 
			count + numberOfToDos at: each]).
	numberOfProblems
		at: aRule
		put: (aRule rules inject: 0 into: [:count :each | 
			count + numberOfProblems at: each]).
		^ self].

	numberOfFalsePositives at: aRule put: ((checker falsePositiveOf: aRule) size).
	numberOfToDos at: aRule put: ((checker toDoOf: aRule) size).
	numberOfProblems at: aRule put: aRule critics size   ! !

!CriticBrowser methodsFor: 'thread' stamp: 'SimonAllier 8/23/2012 15:14'!
updateTree

	thread ifNotNil: [ thread terminate ].
	thread := [ WorldState addDeferredUIMessage: [ 
			rulesModel updateTree ]] fork.! !

ComposableModel subclass: #CriticToolbar
	instanceVariableNames: 'ruleHolder criticHolder browseModel falsepositiveModel transformModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CriticToolbar commentStamp: '<historical>' prior: 0!
I'am a toolbar for the SmallLint Critics


Instance Variables
	browseModel:		<Object>
	criticHolder:		<Object>
	falsepositiveModel:		<Object>
	ruleHolder:		<Object>
	transformModel:		<Object>

browseModel
	- xxxxx

criticHolder
	- xxxxx

falsepositiveModel
	- xxxxx

ruleHolder
	- xxxxx

transformModel
	- xxxxx
!

!CriticToolbar class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:55'!
defaultSpec
<spec>

	^SpecLayout composed
		newRow: [:r |
			r 
				add: #browseModel;
				add: #transformModel;
				add: #falsepositiveModel
			]  height: 25! !

!CriticToolbar methodsFor: 'private' stamp: ''!
browseCritic

	criticHolder contents
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ elem theNonMetaClass  browse]
				ifFalse: [elem browse] ] ! !

!CriticToolbar methodsFor: 'accessing' stamp: ''!
browseModel

	^ browseModel! !

!CriticToolbar methodsFor: 'protocol' stamp: ''!
critic: aCritic

	criticHolder contents: aCritic! !

!CriticToolbar methodsFor: 'accessing' stamp: ''!
falsepositiveModel

	^ falsepositiveModel! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
initialize

	super initialize.

	criticHolder := nil asValueHolder.
	ruleHolder := nil asValueHolder.
	browseModel := self instantiate: ButtonModel.
	transformModel := self instantiate: ButtonModel.
	falsepositiveModel := self instantiate: ButtonModel.

	self setFocusOrder.
	
	self setBrowseModel.
	self setTransformModel.
	self setFalsepositiveModel.

	self registerForChanges.! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 7/24/2012 14:07'!
initializeWidgets! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:55'!
registerForChanges

	criticHolder whenChangedDo: [:contents || boolean |
		boolean := contents notNil.
		browseModel state: (boolean and: [ browseModel enabled ]).
		transformModel state: (boolean and: [ transformModel enabled ]).
		falsepositiveModel state: (boolean and: [ falsepositiveModel enabled ]) ]
! !

!CriticToolbar methodsFor: 'protocol' stamp: ''!
rule: aRule
	
	ruleHolder contents: aRule.
	
	aRule isTransformationRule 
		ifTrue: [transformModel enabled: true]	
		ifFalse: [transformModel enabled: false]
! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setBrowseModel
	
	browseModel
		state: false;
		label: 'Browse';
		action: [ self browseCritic ].
	
! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setFalsepositiveModel
	
	falsepositiveModel
		state: false;
		label: 'False Positive';
		action: [  ].
	
! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setFocusOrder

	self focusOrder
		add: browseModel;
		add: transformModel;
		add: falsepositiveModel.
		! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
setTransformModel
	
	transformModel
		state: false;
		label: 'Transform';
		action: [ self transformCritic ].
	
! !

!CriticToolbar methodsFor: 'private' stamp: ''!
transformCritic

	| changeCode rule selection |
	
	rule := ruleHolder contents
		ifNotNil: [:r | r ].
	rule isTransformationRule 
		ifFalse: [^ self].
			
	selection := criticHolder contents
		ifNotNil: [:critic | critic].			
	selection ifNotNil: [	
		changeCode := (rule changes detect: [:ch |
			((ch changeClassName) = (selection methodClass name)) & (ch selector = selection selector)]) source.
	
		selection methodClass compile: changeCode]! !

!CriticToolbar methodsFor: 'accessing' stamp: ''!
transformModel

	^ transformModel! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
whenFalsePositiveClickedDo: aBlock

	self falsepositiveModel whenActionPerformedDo: aBlock! !

!CriticToolbar methodsFor: 'initialization' stamp: ''!
whenTransformClickedDo: aBlock

	self transformModel whenActionPerformedDo: aBlock! !

ComposableModel subclass: #SelectBrowser
	instanceVariableNames: 'toSelectModel selectedModel addButtonModel addAllButtonModel removeButtonModel removeAllButtonModel nextButtonModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!SelectBrowser commentStamp: '<historical>' prior: 0!
A simple selection browser.!

!SelectBrowser class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:56'!
defaultSpec

		<spec>
	
	^ SpecLayout composed
		newColumn: [:c |
			c
			newRow: [:r |
				r 
					add: #toSelectModel;
					addSplitter;
					add:  #selectedModel];
			newRow: [:r |
				r 
					add:#addButtonModel;
					add:#addAllButtonModel;
					add:#removeButtonModel;
					add:#removeAllButtonModel;
					add: #nextButtonModel ] height: 25]	! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
addAllButtonModel
	^ addAllButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
addButtonModel
	^ addButtonModel! !

!SelectBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 11/24/2012 16:34'!
initializeWidgets

	self instantiateModels: #(
		addButtonModel ButtonModel
		addAllButtonModel ButtonModel 
		removeButtonModel ButtonModel
		removeAllButtonModel ButtonModel
		nextButtonModel ButtonModel ).
		
	self setFocusOrder.

	self setAddButtonModel. 
	self setAddAllButtonModel. 
	self setRemoveButtonModel. 
	self setRemoveAllButtonModel. 
	self setNextButtonModel. ! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
items: aCollection
	
	toSelectModel items: (self sort: aCollection)
! !

!SelectBrowser methodsFor: 'private' stamp: ''!
nextAction
	self subclassResponsibility
! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
nextButtonModel
	^ nextButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
removeAllButtonModel
	^ removeAllButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
removeButtonModel
	^ removeButtonModel! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
selectedModel
	^ selectedModel! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setAddAllButtonModel
	
	addAllButtonModel
		state: false;
		label: 'Add All';
		action: [ self  addAllItems].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:37'!
setAddButtonModel
	
	addButtonModel
		state: false;
		label: 'Add';
		action: [ self addItems ].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setFocusOrder

	self focusOrder
		add: addButtonModel;
		add: addAllButtonModel;
		add: removeButtonModel;
		add: removeAllButtonModel.
		! !

!SelectBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:37'!
setNextButtonModel
	
	nextButtonModel
		state: false;
		label: 'Next';
		action: [ self  nextAction ].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:37'!
setRemoveAllButtonModel
	
	removeAllButtonModel
		state: false;
		label: 'Remove All';
		action: [ self  removeAllItems ].
	
! !

!SelectBrowser methodsFor: 'initialization' stamp: ''!
setRemoveButtonModel
	
	removeButtonModel
		state: false;
		label: 'Remove';
		action: [ self removeItems ].
	
! !

!SelectBrowser methodsFor: 'accessing' stamp: ''!
toSelectModel
	^ toSelectModel! !

SelectBrowser subclass: #SelectPackageBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!SelectPackageBrowser commentStamp: '<historical>' prior: 0!
To select packages.!

!SelectPackageBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 3/29/2012 15:46'!
open
	
	self new items: MCWorkingCopy allManagers;
		openWithSpec ! !

!SelectPackageBrowser class methodsFor: 'specs' stamp: ''!
title
	^ 'Select packages'! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'StephaneDucasse 11/21/2012 18:16'!
addAllItems

	| tmp |
	tmp := self sort: (selectedModel listItems asOrderedCollection addAll: (toSelectModel listItems);yourself ).
	selectedModel  items: tmp.
	toSelectModel  items: {}.
	toSelectModel updateList.
	selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'StephaneDucasse 11/21/2012 18:16'!
addItems
	
	toSelectModel selectedItems
		ifNotNil: [ :items |  
			selectedModel items: (self sort:(selectedModel listItems asOrderedCollection addAll: items; yourself) ).
			toSelectModel items: (self sort:(toSelectModel listItems asOrderedCollection removeAll: items; yourself) ) ].
		toSelectModel updateList.
		selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'initialize-release' stamp: 'StephaneDucasse 11/21/2012 18:16'!
initialize

	| wrappingBlock |
	super initialize.	
	toSelectModel := self instantiate: ListComposableModel.
	selectedModel := self instantiate: ListComposableModel.
	selectedModel beMultipleSelection.
	toSelectModel beMultipleSelection.
	
	wrappingBlock := [:package |
		package packageName].
	
	toSelectModel displayBlock: wrappingBlock.
	selectedModel displayBlock: wrappingBlock.! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'StephaneDucasse 11/21/2012 18:17'!
nextAction

	| env package|	
	package := (selectedModel listItems) collect: [ :each | each package packageSet ].
	env := RBPackageEnvironment new packages: package.
	SelectRuleBrowser openWithEnvironment: env.
	self delete
	
		
! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'StephaneDucasse 11/21/2012 18:17'!
removeAllItems

	| tmp |
	tmp := self sort: (toSelectModel listItems asOrderedCollection addAll: (selectedModel listItems);yourself ).
	toSelectModel   items: tmp.
	selectedModel items: {}.
	toSelectModel updateList.
	selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'StephaneDucasse 11/21/2012 18:18'!
removeItems
	
	selectedModel selectedItems
		ifNotNil: [:items | 
			toSelectModel items: ( self sort: (toSelectModel listItems asOrderedCollection addAll: items; yourself)).
			selectedModel items: (self sort: (selectedModel listItems asOrderedCollection removeAll: items; yourself)).
			].
		toSelectModel updateList.
		selectedModel updateList.  	  ! !

!SelectPackageBrowser methodsFor: 'private' stamp: 'SimonAllier 5/21/2012 16:09'!
sort: aCollection
	
	^ aCollection asOrderedCollection sort: [:e1 :e2 | (e1 asString) < (e2 asString)].! !

SelectBrowser subclass: #SelectRuleBrowser
	instanceVariableNames: 'environment selectRule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!SelectRuleBrowser commentStamp: '<historical>' prior: 0!
To select rules.!

!SelectRuleBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 7/31/2012 10:52'!
openWithEnvironment: aEnv
	
	self new items: (RBCompositeLintRule allGoodRules rules);
		environment: aEnv;
		openWithSpec;
		updateTree . ! !

!SelectRuleBrowser class methodsFor: 'specs' stamp: ''!
title
	^ 'Select rules'! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'Sd 11/30/2012 17:38'!
addAllItems
	
	toSelectModel getRoots do: [:item |  
		selectRule addAll: (item leaves) ].
	self updateTree.  	  ! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'Sd 11/30/2012 17:38'!
addItems
	
	toSelectModel selectedItem
		ifNotNil: [ :item |  
			selectRule addAll: (item leaves) ].
	self updateTree   	  ! !

!SelectRuleBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/24/2012 17:11'!
defaultRulesRootName

	^ 'Selected Rules'! !

!SelectRuleBrowser methodsFor: 'accessing' stamp: ''!
environment: aEnv
	environment := aEnv! !

!SelectRuleBrowser methodsFor: 'initialize-release' stamp: 'Sd 11/30/2012 17:39'!
initialize

	| wrappingBlock childrenBlockS childrenBlockTS |
	super initialize.
	
	toSelectModel := self instantiate: TreeModel.
	selectedModel := self instantiate: TreeModel.
	selectRule := Set new.
		
	 childrenBlockS := [:rule | 
		rule isComposite 
			ifTrue: [rule rules select: [ :r |
					(selectRule anySatisfy:  [:sr | sr = r]) or: [r isComposite] ]]
			 ifFalse: [{}]]. 
	 childrenBlockTS := [ :rule | 
		rule isComposite 
			ifTrue: [rule rules select: [:r |
					(selectRule anySatisfy: [:sr | sr = r]) not or: [r isComposite]]]
			 ifFalse: [{}] ]. 

	toSelectModel childrenBlock: childrenBlockTS.
	selectedModel childrenBlock: childrenBlockS.
	wrappingBlock := [ :rule | rule name ].
	
	toSelectModel displayBlock: wrappingBlock.
	selectedModel displayBlock: wrappingBlock.! !

!SelectRuleBrowser methodsFor: 'accessing' stamp: 'SimonAllier 5/22/2012 10:45'!
items: aCollection
	
	toSelectModel roots: aCollection.
	selectedModel roots: aCollection
! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'StephaneDucasse 12/22/2012 19:51'!
nextAction
	| rules rbRule |
	self delete.	
	rules := selectedModel getRoots.
	rules
		do: [ :each | 
			each leaves
				do: [ :leave | 
					(selectRule anySatisfy: [ :r | r = leave ])
						ifFalse: [ each removeRule: leave ] ] ].
	rules := rules select: [ :each | each rules isEmpty not ].
	rbRule := (RBCompositeLintRule new
				name: self defaultRulesRootName;
				rules: rules).
				
	CriticWorkingConfiguration current
		rule: rbRule;
		environment: environment.
	
	CriticBrowser
		openOnWorkspace: CriticWorkingConfiguration current.! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'Sd 11/30/2012 17:39'!
removeAllItems
	
	selectedModel getRoots do: [ :item |  
		selectRule removeAllFoundIn: (item leaves)].
	self updateTree 	  ! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'StephaneDucasse 11/21/2012 18:24'!
removeItems
	
	selectedModel selectedItem
		ifNotNil: [ :item |  
			selectRule removeAllFoundIn: (item leaves) ].
	self updateTree  	  ! !

!SelectRuleBrowser methodsFor: 'protocol' stamp: 'StephaneDucasse 11/21/2012 18:24'!
updateTree

	toSelectModel updateTree.
	selectedModel updateTree.  	  ! !

ComposableModel subclass: #SingleRuleCriticBrowser
	instanceVariableNames: 'rule criticsModel toolbarModel sourceCodeModel critics textInputFieldModel checker thread'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

SingleRuleCriticBrowser class
	instanceVariableNames: 'icons'!

!SingleRuleCriticBrowser commentStamp: '<historical>' prior: 0!
I am a browser for the SmallLint Critics of a rule.!

SingleRuleCriticBrowser class
	instanceVariableNames: 'icons'!

!SingleRuleCriticBrowser class methodsFor: 'specs' stamp: 'SimonAllier 9/28/2012 13:53'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
		newColumn: [:c |
			c 
				add: #criticsModel;
				add: #toolbarModel height: 25;
				addSplitter;
				add: #textModel ]! !

!SingleRuleCriticBrowser class methodsFor: 'icons' stamp: 'StephaneDucasse 11/21/2012 18:11'!
exclamationIcon 

	^  icons
			at: #'exclamationIcon'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self  exclamationIconContents readStream) ].
! !

!SingleRuleCriticBrowser class methodsFor: 'icons' stamp: 'StephaneDucasse 11/21/2012 18:11'!
exclamationIconContents
	"Private - Method generated"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJPSURBVDjLpZPLS5RhFMYfv9QJ
lelTQZwRb2OKlKuINuHGLlBEBEOLxAu46oL0F0QQFdWizUCrWnjBaDHgThCMoiKkhUONTqmj
mDp2GZ0UnWbmfc/ztrC+GbM2dXbv4ZzfeQ7vefKMMfifyP89IbevNNCYdkN2kawkCZKfSPZT
OGTf6Y/m1uflKlC3LvsNTWArr9BT2LAf+W73dn5jHclIBFZyfYWU3or7T4K7AJmbl/yG7EtX
1BQXNTVCYgtgbAEAYHlqYHlrsTEVQWr63RZFuqsfDAcdQPrGRR/JF5nKGm9xUxMyr0YBAEXX
HgIANq/3ADQobD2J9fAkNiMTMSFb9z8ambMAQER3JC1XttkYGGZXoyZEGyTHRuBuPgBTUu7V
SnUAgAUAWutOV2MjZGkehgYUA6O5A0AlkAyRnotiX3MLlFKduYCqAtuGXpyH0XQmOj+TIURt
51OzURTYZdBKV2UBSsOIcRp/TVTT4ewK6idECAihtUKOArWcjq/B8tQ6UkUR31+OYXP4sTOd
isivrkMyHodWejlXwcC38Fvs8dY5xaIId89VlJy7ACpCNCFCuOp8+BJ6A631gANQSg1mVmOx
xGQYRW2nHMha4B5WA3chsv22T5/B13AIicWZmNZ6cMchTXUe81Okzz54pLi0uQWp+TmkZqMw
xsBV74Or3od4OISPr0e3SHa3PX0f3HXKofNH/UIG9pZ5PeUth+CyS2EMkEqs4fPEOBJLsysk
e48/+xD8oxcAYPzs4QaS7RR2kbLTTOTQieczfzfTv8QPldGvTGoF6/8AAAAASUVORK5CYII='! !

!SingleRuleCriticBrowser class methodsFor: 'initialization' stamp: 'StephaneDucasse 11/21/2012 18:11'!
initialize
	
	icons := IdentityDictionary new! !

!SingleRuleCriticBrowser class methodsFor: 'specs' stamp: ''!
title

	^ 'Critic Browser'! !

!SingleRuleCriticBrowser class methodsFor: 'icons' stamp: 'StephaneDucasse 11/21/2012 18:13'!
wrenchOrangeIcon

	^  icons
			at: #'wrenchOrangeIcon'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self  wrenchOrangeIconContents readStream) ].
! !

!SingleRuleCriticBrowser class methodsFor: 'icons' stamp: 'StephaneDucasse 11/21/2012 18:13'!
wrenchOrangeIconContents
	"Private - Method generated"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAHaSURBVDjLlZO7a1NRHMfzfzhI
KQ5OHR1ddRRBLA6lg4iTd5PSas37YR56Y2JiHgg21uoFxSatCVFjbl5iNBBiMmUJgWwZhCB4
pR9/V4QKfSQdDufF5/v7nu85xwJYprV0Oq0kk8luIpEw4vG48f/eVDiVSikCTobDIePxmGg0
yokEBO4OBgNGoxH5fJ5wOHwygVgsZpjVW60WqqqWzbVgMIjf78fn8xlTBcTy736/T7VaJRQK
fQoEArqmafR6Pdxu9/ECkUjkglje63Q6NBoNisUihUKBcrlMpVLB6XR2D4df3VQnmRstsWzU
63WazSZmX6vV0HWdUqmEw+GY2Gw25SC8dV1l1wrZNX5s3qLdbpPL5fB6vXumZalq2O32rtVq
VQ6GuGnCd+HbFnx9AZrC+MkSHo/np8vlmj/M7f4ks6yysyawgB8fwPv70HgKG8v8cp/7fFRO
/+AllewqNJ/DhyBsi9A7J1QTkF4E69mXRws8u6ayvSJwRqoG4K2Md+ygxyF5FdbPaMfdlIXU
ZfiyAUWx/OY25O4JHBP4CtyZ16a9EwuRi1CXs+5K1ew6lB9DXERX517P8tEsPDzfNIP6C5Ye
QewSrJyeCd4P0bnwXYISy3MCn5oZNtsf3pH46e7XBJcAAAAASUVORK5CYII='! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:40'!
addAllCriticToFalsePositive: aSetOfCritic on: aManifestBuilder
	
	| ruleId versionId  |
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	(aManifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
		ifFalse: [aManifestBuilder installFalsePositiveOf: ruleId version: versionId].		
	 aManifestBuilder addAllFalsePositive: aSetOfCritic of: ruleId version: versionId.
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:40'!
addAllCriticsToFalsePositive

	(criticsModel listItems 
		groupedBy: [:each | checker manifestBuilderOf: each]) 
			keysAndValuesDo: [:key :value | 
					self addAllCriticToFalsePositive: value on: key].
	self updateList
			! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:40'!
addClassToFalsePositive

	| manifestBuilder |
	criticsModel selectedItems ifNotNil: [ :items |
		items do: [ :critic |
			manifestBuilder := checker manifestBuilderOf: critic.
			critic isCompiledMethod 
				ifTrue: [ manifestBuilder addRejectClass: critic methodClass]
				ifFalse: [ manifestBuilder addRejectClass: critic]].
		self updateList ]	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 11/24/2012 17:14'!
addCriticToFalsePositive

	criticsModel selectedItems
		ifNotNil: [:items | 
			(items groupedBy: [:each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [:key :value |
					self addAllCriticToFalsePositive: value on: key]].
		self updateList! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:40'!
addCriticToFalsePositive: aCritic

	| ruleId versionId manifestBuilder |
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	manifestBuilder := checker manifestBuilderOf: aCritic.
	(manifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
		ifFalse: [manifestBuilder installFalsePositiveOf: ruleId version: versionId].		
	 manifestBuilder addFalsePositive: aCritic of: ruleId version: versionId.
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:41'!
addCriticToToDo

	|  ruleId versionId |
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	criticsModel selectedItems 
		ifNotNil: [:items | 
			(items groupedBy: [:each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [:manifestBuilder :critis |
					(manifestBuilder hasToDoOf: ruleId version: versionId) 
						ifFalse: [manifestBuilder installToDoOf: ruleId version: versionId].
	 				manifestBuilder addAllToDo: critis of: ruleId version: versionId]].
	
	self updateList
	 ! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:41'!
addCriticWithCommentToFalsePositive
	
	| aCritic |
	aCritic := criticsModel selectedItem.
	aCritic isNil 
		ifTrue: [ ^ self ]. 
	self addCriticToFalsePositive: aCritic.
	self  updateList.
	CommentFalsePositiveWindow openOnCritic: aCritic onRule: rule. 

	
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:41'!
addCriticWithCommentToToDo

	| aCritic |
	aCritic := criticsModel selectedItem.
	aCritic isNil 
		ifTrue: [^ self]. 
	self addCriticToToDo.
	CommentToDoWindow openOnCritic: aCritic onRule: rule. 
	
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:41'!
addRuleToFalsePositive

	| manifestBuilder |
	criticsModel selectedItems ifNotNil: [ :criticss |
		criticss do: [ :critic |
		manifestBuilder := checker manifestBuilderOf: critic. 
		manifestBuilder addRejectRule: rule class uniqueIdentifierName]].
	self updateList
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:42'!
browseCritic

	criticsModel selectedItem
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ elem theNonMetaClass browse ]
				ifFalse: [ elem browse ] ] ! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 3/29/2012 10:40'!
checker: aChecker
 
	checker := aChecker! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 5/21/2012 15:31'!
critics: aCollectionOfcritic

	 criticsModel  items: aCollectionOfcritic
	! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: ''!
criticsModel

	^ criticsModel! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:42'!
criticsModelContains: aCritic

	^ criticsModel listItems anySatisfy: [:each |
		aCritic isCompiledMethod
			ifTrue: [
				 each isCompiledMethod 
					ifTrue: [ each methodClass = aCritic methodClass and: [ each selector = aCritic selector ]]
					ifFalse: [false]
				 ]
			ifFalse: [each = aCritic ] ]! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'SimonAllier 8/28/2012 10:55'!
defaultColor

	^ Color red! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: ''!
falsePositiveColor

	^ Color darkGray! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:43'!
formatCritic: aCritic
	| result |
	result := aCritic isCompiledMethod
		ifTrue: [ String streamContents: [:s | 
				s << aCritic methodClass name << '>>#' << aCritic selector ]]
		ifFalse: [ aCritic name ].
	result := String streamContents: 
					[:s | s   
						<< result 
						<< ' (' 
						<< (checker manifestBuilderOf: aCritic) packageName 
						<< ')' ].
	^ result! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/24/2012 17:15'!
iconFor: anItem
	| manifestBuilder ruleId ruleVersion |
	ruleId := rule class uniqueIdentifierName.
	ruleVersion := rule class identifierMinorVersionNumber.
	^  (checker isFalsePositive: anItem forRuleId:  ruleId versionId: ruleVersion) 
			ifFalse: [(checker isToDo: anItem forRuleId:  ruleId versionId: ruleVersion)
				ifTrue: [ self class wrenchOrangeIcon ]
				ifFalse: [ self class exclamationIcon ] ]! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 11/24/2012 17:16'!
implementorsOfCritic

	criticsModel selectedItem
		ifNotNil: [ :item | 
			item isBehavior 
				ifTrue: [ item theNonMetaClass  browse]
				ifFalse: [ AbstractTool new browseMessagesFrom:  item selector ]] ! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'StephaneDucasse 11/21/2012 17:50'!
initializeActionToPerformOnTextModel
	| selectedItem |
	
	sourceCodeModel acceptBlock:  [:text | 	
		selectedItem := criticsModel selectedItem.
		((selectedItem isCompiledMethod) and: [rule isTransformationRule not])
			ifTrue: [ selectedItem methodClass compile: text ] 
			ifFalse: [ Compiler evaluate:  text ]]
	
! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:44'!
initializeDisplayCritic: aCritic forRuleId: ruleId versionId: versionId 
	
	| criticRepresentation | 
	criticRepresentation := (self formatCritic: aCritic) asMorph.
	^ (checker isFalsePositive: aCritic forRuleId:  ruleId versionId: versionId) 
			ifTrue: [ criticRepresentation color: self falsePositiveColor ]
			ifFalse: [ (checker isToDo: aCritic forRuleId:  ruleId versionId: versionId)
						ifTrue: [ criticRepresentation color: self toDoColor ]
						ifFalse: [ criticRepresentation color: self defaultColor ]]! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 9/28/2012 13:53'!
initializePresenter

	self whenSelectedItemChangesOnListModel.
	

! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:44'!
initializeTextInputFieldModel

	textInputFieldModel := self instantiate: TextInputFieldModel.
	textInputFieldModel 
		autoAccept: true;
		ghostText: 'Search field';
		removeEntryCompletion.
	
	textInputFieldModel acceptBlock: [: text | |matchText|
		matchText := '*', text, '*'.
		self critics: (text isEmpty 
			ifTrue: [critics]
			ifFalse: [ critics select: [:critic |
				matchText match: (self formatCritic: critic)]]).
		self updateList]
! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'StephaneDucasse 11/21/2012 17:51'!
initializeToolBar
	
	self toolbarModel whenFalsePositiveClickedDo: [ self addCriticToFalsePositive ].
	self toolbarModel whenTransformClickedDo: [ self removeSelectedItemFromListModel ].
	
! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'StephaneDucasse 11/21/2012 17:51'!
initializeWidgets

	self instantiateModels: #(
		criticsModel IconListModel
		sourceCodeModel TextModel 
		toolbarModel CriticToolbar ).

	criticsModel beMultipleSelection.
		
	self initializeTextInputFieldModel.
	self initializeToolBar.
	self initializeActionToPerformOnTextModel.

	criticsModel displayBlock: [:selec |
		self 
			initializeDisplayCritic: selec 
			forRuleId: (rule class uniqueIdentifierName)
			versionId: (rule class identifierMinorVersionNumber) ]. 
	
	criticsModel menu: [:a :b | self menu: a shifted: b ].
	criticsModel icons: [:item | self iconFor: item ].
	
	self focusOrder
		add: criticsModel;
		add: toolbarModel;
		add: sourceCodeModel.
! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:45'!
menu: aMenu shifted: aBoolean

	aMenu
		add: 'Browse' translated
			target: self
			selector: #browseCritic;
		add: 'Senders' translated
			target: self
			selector: #sendersOfCritic;
		add: 'Implementors' translated
			target: self
			selector: #implementorsOfCritic;
		addLine;
		add: 'Mark selected critic as false Positive' translated
			target: self
			selector: #addCriticToFalsePositive;
		add: 'Mark selected critic as false Positive with a comment' translated
			target: self
			selector: #addCriticWithCommentToFalsePositive;
		add: 'Unmark selected critic as false Positive' translated 
			target: self
			selector: #removeCriticToFalsePositive;
		add: 'Mark all critics as false Positive' translated
			target: self
			selector: #addAllCriticsToFalsePositive;
		add: 'Unmark all critics as false Positive' translated
			target: self
			selector: #removeAllCriticsToFalsePositive;
		addLine;
		add: 'Mark selected critic as TODO' translated
			target: self
			selector: #addCriticToToDo;
		add: 'Mark selected critic as TODO with comment' translated
			target: self
			selector: # addCriticWithCommentToToDo;
		add: 'Unmark selected critic as TODO' translated
			target: self
			selector: #removeCriticToToDo;
		addLine;
		add: 'Mark selected class as false Positive' translated
			target: self
			selector: #addClassToFalsePositive;
		add: 'Unmark selected class as false Positive' translated
			target: self
			selector: #removeClassToFalsePositive;
		addLine;
		add: 'Ban this rule for the selected package' translated
			target: self
			selector: #addRuleToFalsePositive;
		add: 'Unban this rule for the selected package' translated
			target: self
			selector: #removeRuleToFalsePositive.
	^ aMenu! !

!SingleRuleCriticBrowser methodsFor: 'message handling' stamp: 'SimonAllier 5/21/2012 14:28'!
perform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	^ (self respondsTo: selector) ifTrue: [self perform: selector] ifFalse: [otherTarget perform: selector]! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:45'!
removeAllCriticToFalsePositive: aSetOfCritic on: aManifestBuilder
	
	| ruleId versionId  |
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	(aManifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifTrue: [ aManifestBuilder removeAllFalsePositive: aSetOfCritic of: ruleId version: versionId].
				
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:46'!
removeAllCriticsToFalsePositive

	(criticsModel  listItems groupedBy: [:each | checker manifestBuilderOf: each]) 
		keysAndValuesDo: [:key :value |
			self removeAllCriticToFalsePositive: value on: key].
	self updateList
			! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:46'!
removeClassToFalsePositive

	| manifestBuilder |
	criticsModel selectedItems
		ifNotNil: [:criticss | criticss do: [:critic |
			manifestBuilder := checker manifestBuilderOf: critic. 
			critic isCompiledMethod 
				ifTrue: [ manifestBuilder removeRejectClass: critic methodClass]
				ifFalse: [ manifestBuilder removeRejectClass: critic theNonMetaClass ]]].
	self  updateList
	! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 11/21/2012 17:54'!
removeCriticToFalsePositive
	criticsModel selectedItems
		ifNotNil: [:criticss | 
			(criticss groupedBy: [ :each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [ :key :value |
					self removeAllCriticToFalsePositive: value on: key]].
		self updateList! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:46'!
removeCriticToToDo

	|  ruleId versionId |
	ruleId :=  rule class uniqueIdentifierName.
	versionId :=   rule class identifierMinorVersionNumber.
	criticsModel selectedItems 
		ifNotNil: [:criticss | 
			(criticss groupedBy: [:each | checker manifestBuilderOf: each]) 
				keysAndValuesDo: [:manifestBuilder :critis |
					(manifestBuilder hasToDoOf: ruleId version: versionId) 
						ifTrue: [ manifestBuilder removeAllToDo: critis of: ruleId version: versionId]].
	 			].
	
	self updateList
	 ! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'Sd 11/30/2012 17:47'!
removeRuleToFalsePositive

	| manifestBuilder |
	criticsModel selectedItems ifNotNil: [ :criticss |
		criticss do: [ :critic |
			manifestBuilder := checker manifestBuilderOf: critic.
			manifestBuilder removeRejectRule: rule class uniqueIdentifierName]].
	self  updateList
	! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'Sd 11/30/2012 17:47'!
removeSelectedItemFromListModel

	| item block |
	item := criticsModel selectedItem.
	block := item isCompiledMethod
		ifTrue: [ [ :each | each methodClass = item methodClass 
									and: [ each selector = item selector ] ] ]
		ifFalse: [ [ :each | each = item ] ].
	criticsModel items: (criticsModel listItems reject: block).
	self resetSelection.
	self  updateList! !

!SingleRuleCriticBrowser methodsFor: 'protocol' stamp: ''!
resetSelection

	self criticsModel resetSelection! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:48'!
rule: aRule

	rule := aRule.
	(rule isNil or: [rule isComposite ]) 
		ifTrue: [ ^ self].	
	critics := rule critics.
	criticsModel items: rule critics.
	toolbarModel rule: rule.! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: ''!
selectionIntervalFor: aString
	^ rule result selectionIntervalFor: aString! !

!SingleRuleCriticBrowser methodsFor: 'menu' stamp: 'StephaneDucasse 11/21/2012 17:55'!
sendersOfCritic

	| abstractTool |
	abstractTool := AbstractTool new. 	
	criticsModel selectedItem
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ abstractTool browseClassRefsOf: elem]
				ifFalse: [abstractTool browseSendersOfMessagesFrom: elem selector] ] ! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:48'!
setTextModelForClass: cl

	| interval |
	sourceCodeModel aboutToStyle: true.
	sourceCodeModel text: cl definition.
	sourceCodeModel behavior: nil .
	
	interval := (self selectionIntervalFor: cl definition).
	interval ifNotNil: [sourceCodeModel setSelection: interval].
	
	
					! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:49'!
setTextModelForMethod: selection

	| interval |
	sourceCodeModel aboutToStyle: true.
	sourceCodeModel text: selection sourceCode.
	sourceCodeModel behavior: selection methodClass.
	interval := self selectionIntervalFor: selection sourceCode.
	interval ifNotNil: [sourceCodeModel setSelection: interval].
	
	
					! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:49'!
setTextModelForNil

	| text |
	text := rule longDescription isEmpty 
		ifTrue: [rule name]
		ifFalse:[rule longDescription]. 
	sourceCodeModel aboutToStyle: false.
	sourceCodeModel text: text.
	sourceCodeModel behavior: nil.
	toolbarModel critic: nil 
	
	
					! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: ''!
setTextModelForTransformationRule: selection
	
	| textDiff change |
	rule result.
	change := rule changes detect: [:ch |
		((ch changeClassName) = (selection methodClass name)) & (ch selector = selection selector)].
	textDiff := (TextDiffBuilder
		from: (selection sourceCode)
		to:  (change source) inClass: selection methodClass) buildDisplayPatch.
	
	sourceCodeModel behavior: nil.
	sourceCodeModel text: textDiff.
	sourceCodeModel aboutToStyle: false.

									
					! !

!SingleRuleCriticBrowser methodsFor: 'private-focus' stamp: 'Sd 11/30/2012 17:49'!
takeKeyboardFocus

	^ super takeKeyboardFocus! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 3/27/2012 17:18'!
textInputFieldModel
	^ textInputFieldModel! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: ''!
textModel

	^ sourceCodeModel! !

!SingleRuleCriticBrowser methodsFor: 'private' stamp: 'SimonAllier 8/28/2012 10:38'!
toDoColor

	^ Color orange! !

!SingleRuleCriticBrowser methodsFor: 'accessing' stamp: ''!
toolbarModel

	^ toolbarModel! !

!SingleRuleCriticBrowser methodsFor: 'thread' stamp: 'BenjaminVanRyseghem 11/24/2012 17:31'!
updateList

	thread ifNotNil: [ thread terminate ].
	thread := [ WorldState addDeferredUIMessage: [ criticsModel updateList ]] fork.! !

!SingleRuleCriticBrowser methodsFor: 'initialization' stamp: 'Sd 11/30/2012 17:48'!
whenSelectedItemChangesOnListModel

	criticsModel whenSelectedItemChanged: [:selection |
		rule isNil ifFalse: [
		(selection
			ifNil: [self setTextModelForNil]
			ifNotNil: [
				toolbarModel critic: selection.
				rule isTransformationRule 
					ifTrue: [self setTextModelForTransformationRule: selection]
					ifFalse: [				
						(rule result isSelectorEnvironment or: [rule result isMultiEnvironment])
							ifTrue: [  self setTextModelForMethod: selection]
							ifFalse:  [ self setTextModelForClass: selection]]
				])]]! !

!RBMultiEnvironment methodsFor: '*Manifest-CriticBrowser' stamp: 'SimonAllier 3/30/2012 11:43'!
isMultiEnvironment
	^ true! !

!RBMultiEnvironment methodsFor: '*Manifest-CriticBrowser' stamp: 'StephaneDucasse 11/21/2012 18:25'!
removeClass: aClass
	environmentDictionaries keys do: [ :key |
		(environmentDictionaries at: key) removeClass: aClass ]! !

Object subclass: #CriticWorkingConfiguration
	instanceVariableNames: 'rule environment'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!CriticWorkingConfiguration commentStamp: '<historical>' prior: 0!
A CriticWorkspace holds the current worspace for the CriticBrowser.

It's composed of the set of rules to check (as a composite rule) and the environment to work in.!

!CriticWorkingConfiguration class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/24/2012 18:05'!
current

	^ Current ifNil: [ Current  := self basicNew initialize ].! !

!CriticWorkingConfiguration class methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/24/2012 18:11'!
exists

	^ Current notNil! !

!CriticWorkingConfiguration class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/24/2012 18:05'!
new

	^ self shouldNotImplement! !

!CriticWorkingConfiguration class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/24/2012 18:05'!
reset

	Current := nil! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 18:04'!
environment
	^ environment! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 18:04'!
environment: anObject
	environment := anObject! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 18:04'!
rule
	^ rule! !

!CriticWorkingConfiguration methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/24/2012 18:04'!
rule: anObject
	rule := anObject! !

Object subclass: #ManifestManifestCriticBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-CriticBrowser'!

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 7/27/2012 10:23'!
rejectClasses
^ #()! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/1/2012 13:34'!
rejectRules
^ #('LawOfDemeterRule' 'TranslateLiteralsInMenusRule' 'MethodHasNoTimeStampRule')! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 9/11/2012 16:06'!
ruleCodeCruftLeftInMethodsRuleV1FalsePositive
^ #()! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'BenjaminVanRyseghem 11/24/2012 17:07'!
ruleEquivalentSuperclassMethodsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SingleRuleCriticBrowser #perform:orSendTo: #false)) #'2012-07-27T10:24:23.09+02:00') #(#(#RGMethodDefinition #(#CriticBrowser #perform:orSendTo: #false)) #'2012-07-27T10:24:23.090000001+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'BenjaminVanRyseghem 11/24/2012 17:07'!
ruleGuardClauseRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#CriticBrowser #removeClass:selector:onRule: #false)) #'2012-08-01T13:34:20.99+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'BenjaminVanRyseghem 11/24/2012 17:07'!
ruleInconsistentMethodClassificationRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#SingleRuleCriticBrowser #takeKeyboardFocus #false)) #'2012-08-22T16:33:48.84+02:00') #(#(#RGMethodDefinition #(#'SelectPackageBrowser class' #title #true)) #'2012-08-22T16:33:48.858+02:00') #(#(#RGMethodDefinition #(#'SelectBrowser class' #defaultSpec #true)) #'2012-08-22T16:33:48.881+02:00') #(#(#RGMethodDefinition #(#CriticBrowser #initializeWidgets #false)) #'2012-08-22T16:34:43.502+02:00') #(#(#RGMethodDefinition #(#CriticBrowser #initialize #false)) #'2012-08-22T16:34:43.516+02:00') #(#(#RGMethodDefinition #(#CriticBrowser #initialExtent #false)) #'2012-08-22T16:37:05.755+02:00') #(#(#RGMethodDefinition #(#CriticBrowser #openWithSpec #false)) #'2012-08-22T16:37:05.767+02:00') #(#(#RGMethodDefinition #(#CriticBrowser #addModelItemsToWindowMenu: #false)) #'2012-08-22T16:39:40.56+02:00') #(#(#RGMethodDefinition #(#SingleRuleCriticBrowser #perform:orSendTo: #false)) #'2012-08-22T16:40:15.182+02:00') #(#(#RGMethodDefinition #(#'CriticRulesBrowser class' #defaultSpec #true)) #'2012-08-22T16:40:36.841+02:00') #(#(#RGMethodDefinition #(#CriticBrowser #perform:orSendTo: #false)) #'2012-08-22T16:41:59.639+02:00') #(#(#RGMethodDefinition #(#SelectPackageBrowser #initialize #false)) #'2012-08-22T16:42:47.043+02:00') #(#(#RGMethodDefinition #(#'SelectRuleBrowser class' #title #true)) #'2012-08-22T16:42:47.054+02:00') #(#(#RGMethodDefinition #(#SelectBrowser #initializeWidgets #false)) #'2012-08-22T16:43:20.929+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/29/2012 13:40'!
ruleMissingSubclassResponsibilityRuleV1FalsePositive
^ #()! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/29/2012 13:40'!
ruleMissingSubclassResponsibilityRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#SelectPackageBrowser #removeAllItems #false)) #'2012-08-01T13:28:23.517+02:00') #(#(#RGMethodDefinition #(#SelectRuleBrowser #removeAllItems #false)) #'2012-08-01T13:28:23.517000001+02:00') #(#(#RGMethodDefinition #(#SelectPackageBrowser #addAllItems #false)) #'2012-08-01T13:28:23.52+02:00') #(#(#RGMethodDefinition #(#SelectRuleBrowser #removeItems #false)) #'2012-08-01T13:28:23.520000001+02:00') #(#(#RGMethodDefinition #(#SelectRuleBrowser #addItems #false)) #'2012-08-01T13:28:23.520000002+02:00') #(#(#RGMethodDefinition #(#SelectPackageBrowser #removeItems #false)) #'2012-08-01T13:28:23.520000003+02:00') #(#(#RGMethodDefinition #(#SelectPackageBrowser #addItems #false)) #'2012-08-01T13:28:23.520000005+02:00') #(#(#RGMethodDefinition #(#SelectRuleBrowser #addAllItems #false)) #'2012-08-29T13:40:56.703+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'BenjaminVanRyseghem 11/24/2012 17:07'!
ruleMissingTranslationsInMenusRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#CriticBrowser #addModelItemsToWindowMenu: #false)) #'2012-07-27T10:23:41.061+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/1/2012 13:27'!
ruleMissingYourselfRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SelectRuleBrowser #nextAction #false)) #'2012-08-01T13:27:54.443+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/23/2012 10:18'!
ruleOnlyReadOrWrittenTemporaryRuleV1FalsePositive
^ #()! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'BenjaminVanRyseghem 11/24/2012 17:07'!
ruleOnlyReadOrWrittenTemporaryRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#CriticBrowser #initializeDisplayBlockForRules #false)) #'2012-08-23T10:18:23.839+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/1/2012 13:28'!
ruleSentNotImplementedRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#SelectBrowser #items: #false)) #'2012-08-01T13:28:05.731+02:00') #(#(#RGMethodDefinition #(#SelectBrowser #setAddButtonModel #false)) #'2012-08-01T13:28:05.731000001+02:00') #(#(#RGMethodDefinition #(#SelectBrowser #setAddAllButtonModel #false)) #'2012-08-01T13:28:05.731000002+02:00') #(#(#RGMethodDefinition #(#SelectBrowser #setRemoveButtonModel #false)) #'2012-08-01T13:28:05.731000003+02:00') #(#(#RGMethodDefinition #(#SelectBrowser #setRemoveAllButtonModel #false)) #'2012-08-01T13:28:05.731000004+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'BenjaminVanRyseghem 11/24/2012 17:07'!
ruleSentNotImplementedRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#SingleRuleCriticBrowser #iconFor: #false)) #'2012-08-29T13:40:08.585+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'BenjaminVanRyseghem 11/24/2012 17:07'!
ruleStringConcatenationRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#CriticBrowser #reapplyAllRules #false)) #'2012-08-22T16:30:38.967+02:00') #(#(#RGMethodDefinition #(#CriticBrowser #applyRules #false)) #'2012-08-22T16:30:38.967000001+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 9/5/2012 14:26'!
ruleTransformationRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#Test #foo #false)) #'2012-09-05T14:26:40.028+02:00') )! !

!ManifestManifestCriticBrowser class methodsFor: 'meta data' stamp: 'SimonAllier 8/1/2012 13:34'!
ruleUnclassifiedMethodsRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#CommentWindow #initialExtent #false)) #'2012-08-01T13:34:12.208+02:00') )! !
SingleRuleCriticBrowser initialize!
